# Generated by Django 4.2 on 2023-05-30 12:33

import django.db.models.deletion
from django.db import migrations, models

import operations.models
import seawatch_registration.models


def up(apps, schema_editor):
    Mission = apps.get_model("missions", "Mission")
    Operation = apps.get_model("operations", "Operation")

    for mission in Mission.objects.all():
        Operation.objects.create(
            **{
                field: getattr(mission, field)
                for field in [
                    "id",
                    "name",
                    "start_date",
                    "end_date",
                    "version",
                ]
            }
        )

    MissionAvailability = apps.get_model("missions", "Availability")
    OperationAvailability = apps.get_model("operations", "Availability")

    for ma in MissionAvailability.objects.all():
        OperationAvailability.objects.create(
            id=ma.id,
            volunteer_id=ma.volunteer_id,
            operation_id=ma.mission_id,
            operation_version=ma.mission_version,
            uid=ma.uid,
            availability=ma.availability,
        )


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("volunteers", "0038_rename_mission_name_experience_operation_name"),
        ("missions", "0028_alter_availability_availability"),
    ]

    operations = [
        migrations.CreateModel(
            name="Availability",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("operation_version", models.IntegerField()),
                (
                    "uid",
                    seawatch_registration.models.ShortTextField(
                        default=operations.models.uuid4_str
                    ),
                ),
                (
                    "availability",
                    seawatch_registration.models.ShortTextField(
                        choices=[
                            ("yes", "yes"),
                            ("no", "no"),
                            ("maybe", "maybe"),
                            ("unknown", "unknown"),
                        ],
                        default="unknown",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "availabilities",
            },
        ),
        migrations.CreateModel(
            name="Operation",
            fields=[
                ("id", models.AutoField(primary_key=True, serialize=False)),
                ("name", seawatch_registration.models.ShortTextField(unique=True)),
                ("start_date", models.DateField()),
                ("end_date", models.DateField()),
                ("version", models.IntegerField(default=0)),
                (
                    "available",
                    models.ManyToManyField(
                        through="operations.Availability", to="volunteers.volunteer"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="availability",
            name="operation",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="operations.operation"
            ),
        ),
        migrations.AddField(
            model_name="availability",
            name="volunteer",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to="volunteers.volunteer"
            ),
        ),
        migrations.RunPython(up),
    ]
